/*
 * ValorCampoDependienteSegunEdad.java
 *
 * Created on 25 de marzo de 2007, 12:47 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
// 9,N22,2,8,30,6
package com.fidufosyga.rules;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import com.fidufosyga.rules.util.ObtenerDiasEntreFechas;
import com.fidufosyga.rules.util.ValidarFecha;

/**
 * 
 * @author Julian
 */
public class ValorCampoDependienteSegunEdad extends AbstractRule {

	String DATE_FORMAT = "dd/MM/yyyy";

	SimpleDateFormat sdf;

	/** Creates a new instance of CampoLlenoParaUnValorDiferenteDeOtroCampo */

	public ValorCampoDependienteSegunEdad() {
		sdf = new SimpleDateFormat(DATE_FORMAT);
		sdf.setLenient(false);
	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {
		String codigoNovedad = registro[new Integer((String) getParams()[0])
				.intValue()];
		if (codigoNovedad.equals((String) getParams()[1])) {

			String fechaNacimiento = registro[new Integer(
					(String) getParams()[2]).intValue()];
			if (!ValidarFecha.esFecha(fechaNacimiento))
				return false;
			Date dtFechaNacimiento;

			try {
				dtFechaNacimiento = sdf.parse(fechaNacimiento);
			} catch (Exception e) {
				return false;
			}

			long edadDias = ObtenerDiasEntreFechas.calcular(dtFechaNacimiento,
					Calendar.getInstance().getTime());
			;
			int numdias = new Integer((String) getParams()[3]).intValue();

			if (edadDias < numdias && !field.equals(getParams()[4])) {

				return true;

			}

		}
		return false;
	}

}